%Directly borrowed from BMA

function [ P,Q ] = decomposebaseline( A,k,minRating,maxRating)
% A - numUsersxnumMovies rating matrix
% k - number of features
numUsers = size(A,1);
numMovies = size(A,2);
wholemean=full(sum(sum(A))/nnz(A));
userBias = full(computeBias(A'));
movieBias = full(computeBias(A));
P = single([(wholemean/(k-2))*ones(numUsers,k-2) userBias' ones(numUsers,1)]);
Q = single([ones(k-1,numMovies);movieBias]);
overAllMaxElement = -1e-09;
overAllMinElement = +1e+09;
for x = 1:numUsers
    if(overAllMaxElement < max(P(x,:)*Q))
        overAllMaxElement=max(P(x,:)*Q);
    end
    if (overAllMinElement > min(P(x,:)*Q))
        overAllMinElement = min(P(x,:)*Q);
    end       
end
factor1 = 0;
factor2 = 0;
if overAllMinElement < minRating
    factor1 = (wholemean - minRating)/(wholemean - overAllMinElement);
end
if overAllMaxElement > maxRating
    factor2 = (maxRating-wholemean)/(overAllMaxElement-wholemean);
end
%reduce it my additional some factor so that we stay inside the bounds
%to avoid numerical errors.
factor=min(factor1,factor2)-0.01;
if (factor ~=0)
    P(:,end-1) = factor*P(:,end-1);
    Q(end,:)=factor*Q(end,:);
end
end

function[bias]=computeBias(A)
% Get row mean on nonzero elements
rowMean = sum(A,2) ./ sum(A~=0,2);
% Remove divide-by-0
rowMean(isnan(rowMean)) = 0;
% Subtract mean from non-zero elements in each column
A2 = A - bsxfun(@times, rowMean, A~=0);
% Column mean on nonzero elements
bias = sum(A2,1) ./ sum(A2~=0,1);
% Remove divide-by-0
bias(isnan(bias)) = 0;
end

