#include <math.h>
#include "mex.h"

void mexFunction(
        int nlhs,       mxArray *plhs[],
        int nrhs, const mxArray *prhs[]
        )
{
  /*input S_sparse, A1, A2, nz;
  ouput A1*A2'(sparse)*/
  int m, n, k, nzmax;
  mwIndex *irs, *jcs;
  double *val;
  if(nrhs != 4) mexErrMsgTxt ("must have 4 inputs");
  
  irs = mxGetIr(prhs[0]);
  jcs = mxGetJc(prhs[0]);
  val = mxGetPr(prhs[0]);
  double *A1 = mxGetPr(prhs[1]);
  double *A2 = mxGetPr(prhs[2]);
  nzmax = (int) mxGetScalar(prhs[3]);
  
  m = mxGetM(prhs[1]);
  k = mxGetN(prhs[1]);
  n = mxGetM(prhs[2]);
  
  int col_idx = 0;
  int i, j;
  int skip = 0;
  double sse = 0;
  for(i = 0; i < nzmax; i++){
	while(i >= jcs[col_idx]){
      col_idx++;
      //if(col_idx == m_U+1) col_idx = m_U;
    }
	if(irs[i] >= m || col_idx > n){
	  skip++;
	  continue;
	}
	double v = 0;
	for(j = 0; j < k; j++){
	   v += A1[irs[i] + j*m] * A2[ col_idx - 1 + j*n ];
    }
	sse += (v - val[i])*(v - val[i]);
  }
  plhs[0] = mxCreateDoubleScalar( sqrt(sse/(nzmax - skip)) );

}