#include <math.h> /* Needed for the ceil() prototype. */
#include "mex.h"
#include <vector>
//#include <unordered_map>
//#include <utility>
using namespace std;

void mexFunction(
        int nlhs,       mxArray *plhs[],
        int nrhs, const mxArray *prhs[]
        )
{
  //getR: W = A1*A2' + R
  //\bar{Omega} A1*A2' - B(A1*A2' + U2) + U2
  /* input: sparse_T, sparse_U2, A1, A2, r1, r2, nz_U, nz_T     */
  /* output: sparse_T */
  if(nrhs != 8) mexErrMsgTxt ("must have 8 inputs\n");
  double *A1, *A2;
  double r1, r2;
  mwIndex *irs_U,*jcs_U;
  int nz_U, nz_T, m, n, k;
  double *val_U;
  //unordered_map<pair<int, int>, double> hashmap;
  irs_U = mxGetIr(prhs[1]);
  jcs_U = mxGetJc(prhs[1]);
  val_U = mxGetPr(prhs[1]);
  
  //mexPrintf("000");
  A1 = mxGetPr(prhs[2]);
  A2 = mxGetPr(prhs[3]);
  r1 = mxGetScalar(prhs[4]);
  r2 = mxGetScalar(prhs[5]);
  nz_U = (int) mxGetScalar(prhs[6]);
  m = mxGetM(prhs[2]);
  k = mxGetN(prhs[2]);
  n = mxGetM(prhs[3]);
  //m_U = (int) mxGetScalar(prhs[7]);
  nz_T = (int) mxGetScalar(prhs[7]);
  int col_idx = 0;
  int i, j;
  int count = 0;
  vector<int> irs_idx;
  vector<int> jcs_idx;
  vector<double> val_idx;
  //mexPrintf("1111\n");
  for(i = 0; i < nz_U; i++){
    while(i >= jcs_U[col_idx]){
        col_idx++;
        //if(col_idx == m_U+1) col_idx = m_U;
    }
    //B(A1A2' + U2)
    double v = 0;
    for(j = 0; j < k; j++){
	  v += A1[irs_U[i] + j*m] * A2[ col_idx - 1 + j*n ];
    }
    if(v + val_U[i] < r1){
	  count++;
	  irs_idx.push_back( irs_U[i] );
	  jcs_idx.push_back( col_idx - 1 );
      val_idx.push_back( r1 - v );
    }
    if(v + val_U[i] > r2){
	  count++;
	  irs_idx.push_back( irs_U[i] );
      jcs_idx.push_back( col_idx - 1 );
	  val_idx.push_back( r2 - v );
    }
    //hashmap[ make_pair( irs_U[i], col_idx - 1 ) ] = val_U[i];
    //mexPrintf("i: %i, j: %i, v: %f\n", irs_U[i], col_idx - 1, val_U[i]);
  }
  //mexPrintf("DDD\n");
  //mexPrintf("m: %i, n: % i, k: %i\n",m ,n, k);
  //mexPrintf("count121: %i\n", count);
  plhs[0] = mxCreateSparse(m, n, count, mxREAL);
  mwIndex *o_irs, *o_jcs;
  double *o_rrs;  
  o_irs = mxGetIr(plhs[0]);
  o_jcs = mxGetJc(plhs[0]);
  o_rrs = mxGetPr(plhs[0]);

  int n_col = 0;
  o_jcs[0] = 0;
  int pre = 0;
  //mexPrintf("count: %i\n", count);
  for(i = 0; i < count; i++){
    o_irs[i] = irs_idx[i];
    o_rrs[i] = val_idx[i];
    //if(jcs_idx[i + 1] > jcs_idx[i]) {
    //   n_col++;
    //   o_jcs[n_col] = i + 1;
    //}
	if(jcs_idx[i] > pre) {
	  o_jcs[pre + 1] = i;
	  for(n_col = pre + 1; n_col < jcs_idx[i]; n_col++){
		o_jcs[n_col + 1] = o_jcs[n_col];
	  }
	  pre = jcs_idx[i];
    }
  }
  o_jcs[pre + 1] = count;
  for(n_col = pre + 1; n_col < n; n_col++){
	  o_jcs[n_col + 1] = o_jcs[n_col];
  }
  //mexPrintf("finish!\n");
}
