#include <math.h> /* Needed for the ceil() prototype. */
#include "mex.h"
#include <vector>
//#include <unordered_map>
using namespace std;

void mexFunction(
        int nlhs,       mxArray *plhs[],
        int nrhs, const mxArray *prhs[]
        )
{
  // set T( spones(U) ) = 0;
  //input: T, U, m, n, nz_T
  //output: sparse_T
  if(nrhs != 5) mexErrMsgTxt ("must have 5 inputs");
  int m, n, nz_T, i, j;
  mwIndex *irs_T, *jcs_T;
  double *rrs_T;
  mwIndex *irs_U, *jcs_U;
  double *rrs_U;
  mwIndex *o_irs, *o_jcs;
  double *o_rrs;

  irs_T = mxGetIr(prhs[0]);
  jcs_T = mxGetJc(prhs[0]);
  rrs_T = mxGetPr(prhs[0]);

  irs_U = mxGetIr(prhs[1]);
  jcs_U = mxGetJc(prhs[1]);
  rrs_U = mxGetPr(prhs[1]);

  m = (int) mxGetScalar(prhs[2]);
  n = (int) mxGetScalar(prhs[3]);
  nz_T = (int) mxGetScalar(prhs[4]);

  plhs[0] = mxCreateSparse(m, n, nz_T, mxREAL);
  o_irs = mxGetIr(plhs[0]);
  o_jcs = mxGetJc(plhs[0]);
  o_rrs = mxGetPr(plhs[0]);

  for(i = 0; i < n + 1; i++){
    o_jcs[i] = jcs_T[i];
  }
  int col_idx = 0;
  for(i = 0; i < nz_T; i++){
    o_irs[i] = irs_T[i];
    o_rrs[i] = rrs_T[i];
    while(i >= jcs_T[col_idx]){
        col_idx++;
        //if(col_idx == m_U+1) col_idx = m_U;
    }
    int col = col_idx - 1;
    int len = jcs_U[col + 1] - jcs_U[col];
    int k;
    for(k = 0; k < len; k++){
      if( irs_U[ jcs_U[col] + k ] == irs_T[ i ] ){
        o_rrs[i] = 0;
      }
    }
  }


}
