#include <math.h>
#include "mex.h"

void mexFunction(
        int nlhs,       mxArray *plhs[],
        int nrhs, const mxArray *prhs[]
        )
{
  /*input S_sparse, A1, A2, nz;
  ouput A1*A2'(sparse)*/
  mxArray *result;
  int m, n, k, nzmax, i = 0, j = 0;
  /*double *irs,*jcs;*/
  mwIndex *irs, *jcs;
  mwIndex *o_irs, *o_jcs;
  double *o_rrs; 
  /*double *A1, *A2;*/

  if(nrhs != 4) mexErrMsgTxt ("must have 4 inputs");
  
  /*k = mxGetScalar(prhs[0]);*/
  /*double *irs =  mxGetPr(prhs[0]);
  double *jcs =  mxGetPr(prhs[1]);*/
  irs = mxGetIr(prhs[0]);
  jcs = mxGetJc(prhs[0]);
  double *A1 = mxGetPr(prhs[1]);
  double *A2 = mxGetPr(prhs[2]);
  nzmax = (int) mxGetScalar(prhs[3]);

  m = mxGetM(prhs[1]);
  k = mxGetN(prhs[1]);
  n = mxGetM(prhs[2]);

  plhs[0] = mxCreateSparse(m, n, nzmax, mxREAL);
  o_irs = mxGetIr(plhs[0]);
  o_jcs = mxGetJc(plhs[0]);
  o_rrs = mxGetPr(plhs[0]);

  int col_idx = 0;
  for(i = 0; i < n + 1; i++){
    o_jcs[i] = jcs[i];
  }
  for(i = 0; i < nzmax; i++){
    
    o_irs[i] = irs[i];
    o_rrs[i] = 0;
    while(i >= jcs[col_idx]){
	col_idx++;
        /*if(col_idx == m+1) col_idx = m;*/
    }
    /*mexPrintf("Index %d .. %i\n",irs[i],col_idx-1);*/
    for(j = 0; j < k; j++){
      o_rrs[i] += A1[ (int)irs[i] + j*m] * A2[ (int)col_idx - 1 + j*n];
      /*mexPrintf("element %f ... %f\n", A1[ (int)irs[i] + j*n], A2[ (int)col_idx - 1 + j*m] );*/
    }
  }

}
